/* chdmod_I3.c

 Tacitus @ LPUniversity
 24-MAR-06
 I3 Channel Module

*/

/* NOTICE: THIS IS BETA SOFTWARE - USE AT OWN RISK! <-- WARNING */

/* Preproccessor statements */

#include <socket.h>
#include <logs.h>
#include <mudlib.h>

#define DATA_FILE "/data/daemons/i3"

/* Global Variables */

int s;
int isBlocked = 0;
mixed *msg_buffer = ({ });
mapping data;
mapping history;

/* Prototypes */

void create();
int setup_socket();
void connect();
void setup_services();
void send_packet(mixed *packet);

void send_channel_listen(string channel, int flag);
int channel_filter(string channel);

/* Functions */

void create()
{
    log_file(LOG_I3,"Reloading with previous_object being: " + file_name(previous_object()) + "\n");

    data = (["router_password" : 0, "mudlist_id" : 0,
      "mudlist" : ([]), "chanlist" : ([]), "services" : ([]),
      "other" : ([]), "router_list" : ({ ({"*yatmim", "149.152.218.102 23" }) }),
      "listening" : ({}),
    ]);

    history = ([]);

    if(file_exists(DATA_FILE + ".o")) restore_object(DATA_FILE);

    data["listening"] = ({});

    if(!setup_socket())
    {
	log_file(LOG_I3, "Error [i3]: Unable to setup sockets.\n");
	destruct(this_object());
	return;
    }

    setup_services();
    connect();
    write("Success [I3]: Intermud3 Communications Active (" + query_privs(this_object()) + ").\n");
}

void remove()
{
    mixed *packet;

    packet =
    ({
      "shutdown",
      5,
      mud_name(),
      0,
      data["router_list"][0][0],
      0,
      0
    });

    send_packet(packet);
    log_file(LOG_I3, "Notice [i3]: I3 Network Module Destructing.\n");
    CHAN_D->unregisterModule("I3");
    save_object(DATA_FILE);
    socket_close(s);
    s = 0;
}

void setup_services()
{
    /* SERVICES SETUP HERE */
    /* Ensure they get added to (mapping) data["services"] */

    data["services"] = (["channel" : 1]);
}

void connect()
{
    mixed *packet;

    packet =

    ({
      "startup-req-3",
      5,
      mud_name(),
      0,
      data["router_list"][0][0],
      0,
      data["router_password"],
      data["mudlist_id"],
      0,
      port(),
      0,
      0,
      lib_name() + " " + lib_version(),
      baselib_name() + " " + baselib_version(),
      driver_version(),
      "LPMud",
      open_status(),
      admin_email(),
      data["services"],
      data["other"]
    });

    if(s) return;

    log_file(LOG_I3, "Notice [i3]: Sending startup-req-3 packet.\n");

    send_packet(packet);
}


int setup_socket()
{
    int error;

    s = socket_create(MUD, "read_callback", "close_callback");
    if(s < 0)
    {
	log_file(LOG_I3, "Error [i3/socket]: " + socket_error(s) + "\n");
	socket_close(s);
	s = 0;
	return 0;
    }

    error = socket_connect(s, data["router_list"][0][1], "read_callback", "write_callback");

    if(error < 0)
    {
		log_file(LOG_I3, "Error [i3/socket]: " + socket_error(error) + "\n");
		socket_close(s);
		s = 0;
		return 0;
    }

    return 1;
}

void close_callback(int fd)
{
    log_file(LOG_I3, "Warning [i3/socket]: Close callback called - Connection Terminated.\n");
    socket_close(fd);
    s = 0;
    create();
}

void write_callback(int fd)
{
    int error;
    isBlocked = 0;

    log_file(LOG_I3, "Notice [i3]: Write callback called (" + s + ").\n");

    while(sizeof(msg_buffer) > 0)
    {
	error = socket_write(s, msg_buffer[0]);

	switch(error)
	{
	case EESUCCESS :
	    {
		msg_buffer = msg_buffer[1..];
		continue;
	    }

	case EEWOULDBLOCK :
	    {
		isBlocked = 1;
		call_out((: write_callback, s :), 1);
		return;
	    }

	case EECALLBACK :
	    {
		isBlocked = 1;
		return;
	    }

	default :
	    {
		log_file(LOG_I3, "Error [i3/socket] on send: " + socket_error(error) + "\n");
		return;
	    }
	}
    }
}

void send_packet(mixed *packet)
{
    int error;

    error = socket_write(s, packet);

    log_file(LOG_I3, "Sending " + packet[0] + "\n");

    if(isBlocked)
    {
	msg_buffer += ({ packet });
	return;
    }

    switch(error)
    {
    case EESUCCESS :
	{
	    return;
	}

    case EEALREADY :
	{
	    isBlocked = 1;
	    msg_buffer += ({ packet });
	    return;
	}

    case EEWOULDBLOCK :
	{
	    isBlocked = 1;
	    msg_buffer += ({ packet });
	    call_out((: write_callback, s :), 1);
	    return;
	}

    case EECALLBACK :
	{
	    isBlocked = 1;
	    return;
	}

    default :
	{
	    log_file(LOG_I3, "Error [i3/socket] on send: " + socket_error(error) + "\n");
	    return;
	}
    }
}

void read_callback(int fd, mixed packet)
{
    string func;

    catch(log_file(LOG_I3, "Notice [i3]: Rec '" + packet[0] + "'.\n"));

    if(!sizeof(packet)) return 0;

    func = "rec_" + packet[0];
    func = replace_string(func, "-", "_");
    if(function_exists(func, this_object()))
    {
	call_other(this_object(), func, packet);
    }

    else call_other(this_object(), "rec_unsupported", packet);

}

int isAllowed(string channel, string usr, int flag)
{
    if(flag)
    {
	if(member_array(channel, data["listening"]) == -1)
	{
	    send_channel_listen(channel, 1);
	    data["listening"] += ({ channel });
	}
    }
    else
    {
	if(!sizeof(CHAN_D->getTuned(channel)))
	{
	    send_channel_listen(channel, 0);
	    data["listening"] -= ({ channel });
	}
    }

    return 1;
}

int rec_msg(string chan, string usr, string msg)
{
    mixed *packet;
    object ob;

    packet = ({
      "channel-m",
      5,
      mud_name(),
      usr,
      0,
      0,
      chan,
      capitalize(usr),
      msg
    });

    switch(msg) /* We could do some neat stuff here! */
    {
    case "/last" : {

	    ob = find_player(usr);

	    if(!sizeof(history[chan]))
		tell_object(ob, "I3: Channel " + chan + " has no history yet.\n");
	    else
		tell_object(ob, implode(history[chan][(sizeof(history[chan]) - 15)..(sizeof(history[chan]) - 1)], ""));

	    return 1;
	}
    }

    send_packet(packet);
    CHAN_D->rec_msg(chan, sprintf("[%s] %s: %s\n", "%^BOLD%^" + chan + "%^RESET%^", capitalize(usr), msg));
    if(!history[chan]) history[chan] = ({});
    if(sizeof(history[chan]) > 15) history[chan] = history[chan][1..(sizeof(history[chan]))];
    history[chan] += ({ sprintf("%s [%s] %s: %s\n", ctime(time()), "%^BOLD%^" + chan + "%^RESET%^", capitalize(usr), msg) });

    return 1;
}

int channel_filter(string channel)
{
    /* THIS FUNCTION ALLOWS US TO DISALLOW CERTAIN CHANNELS MUD-WIDE */
    /* FOR NOW ALL CHANNELS WILL HAVE TO BE WHITELISTED */
    /* COMMENT EVERYTHING OUT AND RETURN 1 TO DISABLE */
    /* NEXT RELEASE WILL INCLUDE ADMIN-FRONTEND */

    string *allow_list = explode(read_file("/adm/etc/i3_channels"), "\n");

    if(member_array(channel, allow_list) == -1) return 0;
    else return 1;


}

mapping get_mudlist()
{
	mapping copy = data["mudlist"];
	return copy;
}

/* Packet Handlers Below */

void rec_startup_reply(mixed  *packet)
{
    data["router_list"] = packet[6];
    data["router_password"] = packet[7];
    log_file(LOG_I3, "Success [i3]: Connection established to I3 network.\n");
    CHAN_D->registerModule("I3", file_name(this_object()));
    save_object(DATA_FILE);

}

void rec_mudlist(mixed *packet)
{
    data["mudlist_id"] = packet[6];
    data["mudlist"] = packet[7];

}

void rec_chanlist_reply(mixed *packet)
{
    string *localList = CHAN_D->getChls("i3");
    int i;

    data["chanlist_id"] = packet[6];
    data["chanlist"] = packet[7];

    for(i = 0; i < sizeof(localList); i++)
    {
	if(member_array(localList[i], keys(data["chanlist"])) == -1) CHAN_D->removeCh(localList[i]);
	map_delete(history, localList[i]);
    }

    foreach(mixed key, mixed value in data["chanlist"])
    {
	if(!channel_filter(key)) continue;
	CHAN_D->registerCh("I3", key);
	history += ([key : ({}) ]);
    }
}

void rec_error(mixed *packet)
{
    log_file(LOG_I3, "Error [" + packet[6] + "]: " + packet[7] +"\n");
}

/* Channel Service Implementation */

void rec_channel_m(mixed *packet)
{
    if(packet[2] == mud_name()) return;
    CHAN_D->rec_msg(packet[6], sprintf("[%s] %s@%s: %s\n", "%^BOLD%^" + packet[6] + "%^RESET%^", packet[7], packet[2], packet[8]));
    if(!history[packet[6]]) history[packet[6]] = ({});
    if(sizeof(history[packet[6]]) > 15) history[packet[6]] = history[packet[6]][1..(sizeof(history[packet[6]]))];
    history[packet[6]] += ({ sprintf("%s [%s] %s@%s: %s\n", ctime(time()),"%^BOLD%^" + packet[6] + "%^RESET%^", packet[7], packet[2], packet[8]) });
}

void rec_channel_t(mixed *packet)
{
    string message;

    if(find_player(packet[7]) && packet[8] == mud_name() )
    {
	message = packet[10];
	message = replace_string(message, "$N", sprintf("%s@%s", packet[11], packet[2]));
	message = replace_string(message, "$O", packet[12]);
    }
    else
    {
	message = packet[9];
	message = replace_string(message, "$N", sprintf("%s@%s", packet[11], packet[2]));
	message = replace_string(message, "$O", packet[12] + "@" + packet[7]);
    }

    CHAN_D->rec_msg(packet[6], sprintf("[%s] %s\n", "%^BOLD%^" + packet[6] + "%^RESET%^", message));
    if(sizeof(history[packet[6]]) > 15) history[packet[6]] = history[packet[6]][1..(sizeof(history[packet[6]]))];
    history[packet[6]] += ({ sprintf("%s [%s] %s\n", ctime(time()), "%^BOLD%^" + packet[6] + "%^RESET%^", message) });
}

void rec_channel_e(mixed *packet)
{
    string message = packet[8];
    message = replace_string(message, "$N", sprintf("%s@%s", packet[7], packet[2]));
    CHAN_D->rec_msg(packet[6], sprintf("[%s] %s\n", "%^BOLD%^" + packet[6] + "%^RESET%^", message));
    if(sizeof(history[packet[6]]) > 15) history[packet[6]] = history[packet[6]][1..(sizeof(history[packet[6]]))];
    history[packet[6]] += ({ sprintf("%s [%s] %s\n", ctime(time()), "%^BOLD%^" + packet[6] + "%^RESET%^" , message) });
}

void rec_chan_user_req(mixed *packet)
{
    mixed *out_packet;
    int gender;
    object user = find_player(packet[6]);
    if(!user) return;

    if(user->query("gender") == "male") gender = 0;
    else if(user->query("gender") == "female") gender = 1;
    else gender = 2;

    out_packet = ({

      "chan-user-reply",
      5,
      mud_name(),
      0,
      packet[2],
      0,
      query_privs(user),
      capitalize(user->query_name()),
      gender,
    });

    send_packet(out_packet);
}

void send_channel_listen(string channel, int flag)
{
    mixed *packet;

    packet = ({
      "channel-listen",
      5,
      mud_name(),
      0,
      data["router_list"][0][0],
      0,
      channel,
      flag
    });

    send_packet(packet);
}

/* Other Packets */

void rec_locate_req(mixed *packet)
{
    mixed *out_packet;
    mixed user;
    string status;

    user = find_player(packet[6]);

    if(!user)
    {
	user = call_other(FINGER_D, "get_user", packet[6]);
	if(!objectp(user))	return;

	out_packet = ({

	  "locate-reply",
	  5,
	  mud_name(),
	  0,
	  packet[2],
	  packet[3],
	  mud_name(),
	  capitalize(user->query_name()),
	  (interactive(user) ? query_idle(user) : 0),
	  "Offline",
	});
	send_packet(out_packet);
	destruct(user);
	return;
    }

    else
    {
	if(!interactive(user)) status = "Link-Dead";
	else if(query_idle(user)/60 > 10) status = "Idle";
	else status = "Online";
	out_packet = ({

	  "locate-reply",
	  5,
	  mud_name(),
	  0,
	  packet[2],
	  packet[3],
	  mud_name(),
	  capitalize(user->query_name()),
	  (interactive(user) ? query_idle(user) : 0),
	  (status ? status : 0),
	});
	send_packet(out_packet);
	return;
    }



}

string get_rank(object ob);

void rec_who_req(mixed *packet) {
    mixed *msg;

    msg = map(filter(users(), (: (environment($1))  :)),
      (: ({ (string)capitalize($1->query_name()), query_idle($1),
          (string)get_rank($1) }) :));
    send_packet(({ "who-reply", 5, mud_name(), 0, packet[2],
        packet[3], msg }));
}

string get_rank(object ob)
{
	if(adminp(ob)) return "Admin";
	else if(devp(ob)) return "Developer";
	else return "User";
}



void rec_unsupported(mixed *packet)
{
    log_file(LOG_I3, "Warning [i3]: Recieved unsupported packet " + packet[0] + "\n");
}



