/* news_d.c

 Tacitus @ LPUniversity
 27-JAN-06
 News Daemon
*/

/* Preproccessor Statements */

#define DATA_FILE "/data/daemons/news_d"

/* Global Variables */

mapping data;
string *authorizedClients;

/* Functions */

void create()
{
     data = ([]);
     authorizedClients = ({ "/obj/mudlib/newsclients/std_newsclient" });
     restore_object(DATA_FILE);
}

int authorizeClient(string filename)
{
     if(!adminp(this_player())) return 0;

     if(!file_exists(filename)) return 0;

     if(member_array(get_base(previous_object()), authorizedClients) != -1) return 0;

     authorizedClients += ({ filename });

     return 1;
}

int revokeClientAuthorization(string filename)
{
     if(!adminp(this_player())) return 0;

     if(member_array(get_base(previous_object()), authorizedClients) == -1) return 0;

     authorizedClients -= ({ filename });

     return 1;
}

int clientAction_post(string group, string author, string subject, string content)
{
     mapping new_msg;

     if(member_array(get_base(previous_object()), authorizedClients) == -1) return 0;

     if(!data[group]) return 0;

     new_msg = ([
          "group" : group,
          "author" : author,
          "subject" : subject,
          "content" : content,
          "date" : time(),
          "id" : sizeof(data[group]) + 1,
     ]);

     data[group] += ({ new_msg });

     save_object(DATA_FILE);

     return 1;
}

mapping *getPosts(string group)
{
     mapping *ret;

     if(member_array(get_base(previous_object()), authorizedClients) == -1) return 0;

     if(!data[group]) return 0;

     ret = data[group];

     return ret;
}

string *getGroupListings()
{
     if(member_array(get_base(previous_object()), authorizedClients) == -1) return 0;

     return keys(data);
}


int adminAction_deletePost(string group, int id)
{
     if(!adminp(this_player())) return 0;

     if(!data[group]) return 0;

     if(!data[group][id]) return 0;

     map_delete(data[group], id);

     return 1;
}

int adminAction_createGroup(string group)
{
     if(!adminp(this_player())) return 0;

     if(data[group]) return 0;
     data += ([group : ({})]);

     save_object(DATA_FILE);

     return 1;
}

int adminAction_deleteGroup(string group)
{
     if(!adminp(this_player())) return 0;

     if(!data[group]) return 0;
     map_delete(data, group);

     save_object(DATA_FILE);

     return 1;
}
