// tell.c

// Gwegster @ LPUniversity
// 30-JUNE-05
// a tell command

//Last edited on May 5th, 2006 by Tacitus

int main(string str)
{
     string who, message;
     object user;

     if(!str) return(notify_fail("Error [tell]: You must provide an argument. Syntax: tell <player> <message>\n"));

     if(!sscanf(str, "%s %s", who, message)) return(notify_fail("Usage: tell <player> <message>\n"));
 
     user = find_player(lower_case(who));
     
     if(!objectp(user)) return notify_fail("Error [tell]: User " + who + " is not found.\n");
     
     if(user == this_player())
     {
          tell_room(environment(this_player()), capitalize(this_player()->query_name()) + " starts talking to themselves.\n"+ NOR, this_player());
          write(CYN + "You tell yourself: " + NOR + message + "\n"+ NOR);
          return 1;
     }

     tell_object(user, CYN + capitalize((string)this_player()->query_name()) + " tells you: " + NOR + message + "\n" + NOR);
     write(CYN + "You tell " + capitalize(who) + ": " + NOR + message + "\n" + NOR);
     user->set("reply", query_privs(this_player()));
     return 1;
}

string help()
{
     return(HIW + " SYNTAX:" + NOR + " tell <player> <message>\n\n"
     "This command will send a message to the specified player if they\n"
     "are online. For example, if you type 'tell tacitus hey' then\n"
     "he'll see '" + CYN + capitalize(this_player()->query_name()) + " tells you:" + NOR + " hey'.\n\n" +
     HIW + "See also: " + NOR + "say, channel\n");
}


